Subject: Login a FE User with PHP not possible any more in TYPO3 6.2.5
Description

Related to Ticket #60264

In TYPO3 <= 6.2.4 it was possible to login a FE User via userFunc or in a controller with:

$GLOBALS['TSFE']->fe_user->checkPid = '';
$info = $GLOBALS['TSFE']->fe_user->getAuthInfoArray();
$user = $GLOBALS['TSFE']->fe_user->fetchUserRecord($info['db_user'], $username);
$GLOBALS['TSFE']->fe_user->createUserSession($user);
$GLOBALS['TSFE']->fe_user->user = $GLOBALS['TSFE']->fe_user->fetchUserSession();

Now it's not possible any more to login an user because the call of method $this->setSessionCookie(); in createUserSession()
(typo3/sysext/frontend/Classes/Authentication/FrontendUserAuthentication.php) is missing.

Is this a breaking change?
If your changes are correct, what is the correct way to login a FE User?

Related issues:
related to Core - Bug # 60264: felogin permalogin not working with typo3 6.2.... Resolved 2014-07-11

History
#1 - 2014-10-17 09:18 - Thomas Obernberger

I have the same problem

Is there a workaround for this issue?

#2 - 2014-10-17 10:05 - Christian Wolfram

I have the same problem

#3 - 2014-10-20 10:09 - Benjamin Butschell

Same problem here.
#4 - 2014-11-05 14:03 - Thilo Schumann

I am having the same problem and it took me hours to figure it out.

It is also mentioned in the sysext frontend here: 
https://forge.typo3.org/projects/typo3cms-core/repository/revisions/master/entry/typo3/sysext/frontend/Classes/Authentication/FrontendUserAuthentic
tion.php#L251

The problem is fixed by adding this call.

#5 - 2014-11-05 17:11 - Sebastian Haak

I have the same problem.

Any ideas how to handle it?

#6 - 2014-11-06 15:29 - Benedict Burckhart

Here is a really dirty fix for the extensions. But it should work until the bug is resolved.

$reflection = new \ReflectionClass($GLOBALS['TSFE']->fe_user);
$setSessionCookieMethod = $reflection->getMethod('setSessionCookie');
$setSessionCookieMethod->setAccessible(TRUE);
$setSessionCookieMethod->invoke($GLOBALS['TSFE']->fe_user);

Should be called after:

$GLOBALS['TSFE']->fe_user->createUserSession($user);

#7 - 2015-01-10 01:38 - Stefan Neufeind

In the comments in gerrit at https://review.typo3.org/31607 it was mentioned:
[...]
Markus mentioned on Slack that adding a dummy value to the session data forces to set a cookie:
$frontEndUser->setKey('ses', 'dummy', TRUE);

#8 - 2015-01-10 11:46 - Helmut Hummel
- Status changed from New to Needs Feedback

The correct way (API) to authenticate a user is through a login service.
Anything else is working around the API or using internal API, which will cause unexpected behavior.

If someone comes up with a well described use case, I'm happy to help how to do this using the login service API
#9 - 2015-01-10 11:57 - Helmut Hummel

If you like to go on with dirty hacks (which might break in the future), this should do the trick:

$GLOBALS['TSFE']->fe_user->checkPid = '';
$info = $GLOBALS['TSFE']->fe_user->getAuthInfoArray();
$user = $GLOBALS['TSFE']->fe_user->fetchUserRecord($info['db_user'], $username);
$GLOBALS['TSFE']->fe_user->forceSetCookie = TRUE;
$GLOBALS['TSFE']->fe_user->createUserSession($user);
$GLOBALS['TSFE']->fe_user->user = $GLOBALS['TSFE']->fe_user->fetchUserSession();

#10 - 2015-01-10 15:59 - Alex Kellner

Thx for the information. At my point of view, this ticket can be closed now.

But nevertheless: I did not test it but I found an old blog entry which describes how to use an own auth service, if anyone needs a link:
http://jimsuperfly.de/blog/typo3-auth-service/

#11 - 2015-01-16 09:33 - Mirko grothe

My Logic for automatic Login with php.

$info = $GLOBALS['TSFE']->fe_user->getAuthInfoArray();
$user = $GLOBALS['TSFE']->fe_user->fetchUserRecord($info['db_user'],$loginData['uname']);
$login_success = $GLOBALS['TSFE']->fe_user->compareUident($user,$loginData);
if($login_success){
     $userSession = $GLOBALS['TSFE']->fe_user->createUserSession($user);
     $GLOBALS["TSFE"]->fe_user->loginSessionStarted = TRUE;
     $GLOBALS["TSFE"]->fe_user->user = $GLOBALS["TSFE"]->fe_user->fetchUserSession();
     return true;
} else {
    return false;
}

    -  function compareUident ($login_success) return false.
    -  I see the problem in line 1491 ...
    -  ../6.2.9/typo3/sysext/core/Classes/Authentication/AbstractUserAuthentication.php
    -  Field $logindata['uident_text'] does not exist
    -  is expected the password
    -  changes to the field name in uident everything is ok

#12 - 2015-01-16 12:58 - Markus Klein

Hi highly recommend to autologin a user by only creating the session and force a redirect afterwards.
This is the only way the Core will correctly initialize all parts of the system. (Show correct menus etc)

Sample code:
$tsfe = $this->getTypoScriptFrontendController();
$tsfe->fe_user->createUserSession($feUser);
// enforce session so we get a FE cookie, otherwise autologin does not work (TYPO3 6.2.5+)
$tsfe->fe_user->setAndSaveSessionData('dummy', TRUE);
$this->cObj->typolink(
    '',
    [
        'parameter' => 123
    ]
);
$url = $this->cObj->lastTypoLinkUrl;
HttpUtility::redirect($url, HttpUtility::HTTP_STATUS_303);

#13 - 2015-01-29 15:51 - Markus Kappe

Can anyone please provide an example to a login service using TYPO3 6.2 (i.e. that makes use of namespaces etc.)?

Thank you

#14 - 2015-06-08 12:36 - Markus Klein

May I close this ticket?

#15 - 2015-06-08 12:39 - Alex Kellner

Ticket is not assigned to anyone. In my opinion you can close it.

#16 - 2015-06-08 12:50 - Markus Klein
- Status changed from Needs Feedback to Closed

The login is possible again as described above, so all should be good.

#17 - 2015-07-15 13:56 - Dennis Laudenbach

Updated by Markus Kappe 6 months ago
Can anyone please provide an example to a login service using TYPO3 6.2 (i.e. that makes use of namespaces etc.)?

No answer

Updated by Markus Klein about 1 month ago
The login is possible again as described above, so all should be good.

There are serveral ways described above...which one do you mean?
My sample Code:

protected function loginUser($username, $password) {

    $GLOBALS['TSFE']->fe_user->checkPid = '';
    $info = $GLOBALS['TSFE']->fe_user->getAuthInfoArray();
    $user = $GLOBALS['TSFE']->fe_user->fetchUserRecord($info['db_user'], $username);
    $loginData = array('uname' => $username, 'uident' => $password, 'status' => 'login');

    $GLOBALS['TSFE']->fe_user->forceSetCookie = TRUE;
    $GLOBALS['TSFE']->fe_user->createUserSession($user);
    $GLOBALS['TSFE']->fe_user->user = $GLOBALS['TSFE']->fe_user->fetchUserSession();

    $loginSuccess = $GLOBALS['TSFE']->fe_user->compareUident($user, $loginData);

    \TYPO3\CMS\Extbase\Utility\DebuggerUtility::var_dump($loginSuccess);
    die('login');
}

Dumps "False" in TYPO3 6.2.12

So could you please post a tested example before you close the ticket?

Thank you!

#18 - 2015-07-15 19:41 - Markus Klein

See my example https://forge.typo3.org/issues/62194#note-12
